/*
   File: cdl_ds.h
   Generated on Wed Mar 13 13:55:19 2013
*/
#ifndef IncCdl_ds
#define IncCdl_ds

/* standard includes */
#include <stdio.h>

/* support lib includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>
#include <dcg_binfile.h>

/* Introduce record type definitions */
typedef struct str_module *module;
typedef struct str_variable *variable;
typedef struct str_export *export;
typedef struct str_spec *spec;
typedef struct str_psig *psig;
typedef struct str_pdecl *pdecl;
typedef struct str_proc *proc;
typedef struct str_fpar *fpar;
typedef struct str_group *group;
typedef struct str_alternative *alternative;
typedef struct str_member *member;
typedef struct str_apar *apar;
typedef struct str_affix_term *affix_term;
typedef struct str_affix_rule *affix_rule;
typedef struct str_affix_alternative *affix_alternative;
typedef struct str_affix_element *affix_element;
typedef struct str_call_arg *call_arg;
typedef struct str_madm *madm;
typedef struct str_assoc_pair *assoc_pair;
typedef struct str_block *block;
typedef struct str_instr *instr;
typedef struct str_address *address;
typedef struct str_altnr_label_pair *altnr_label_pair;
typedef struct str_iexpr *iexpr;
typedef struct str_rexpr *rexpr;

/* Introduce type_list definitions */
typedef struct str_module_list *module_list;
typedef struct str_variable_list *variable_list;
typedef struct str_export_list *export_list;
typedef struct str_psig_list *psig_list;
typedef struct str_pdecl_list *pdecl_list;
typedef struct str_proc_list *proc_list;
typedef struct str_fpar_list *fpar_list;
typedef struct str_alternative_list *alternative_list;
typedef struct str_member_list *member_list;
typedef struct str_apar_list *apar_list;
typedef struct str_affix_term_list *affix_term_list;
typedef struct str_affix_rule_list *affix_rule_list;
typedef struct str_affix_alternative_list *affix_alternative_list;
typedef struct str_affix_element_list *affix_element_list;
typedef struct str_call_arg_list *call_arg_list;
typedef struct str_madm_list *madm_list;
typedef struct str_state_list *state_list;
typedef struct str_assoc_pair_list *assoc_pair_list;
typedef struct str_block_list *block_list;
typedef struct str_address_list *address_list;
typedef struct str_altnr_label_pair_list *altnr_label_pair_list;
typedef struct str_char_list *char_list;

/* Introduce enumeration types */
typedef enum
{ none, prelude, interlude,
  postlude, function, test,
  action, predicate
} proc_type;

typedef enum
{ d_unknown, d_inherited, d_derived,
  d_transient
} dir;

typedef enum
{ undetermined, equal, split,
  join, assign, arith_join,
  arith_split
} guard_type;

typedef enum
{ f_success, f_failure, f_abort,
  f_exit
} flow_op;

typedef enum
{ undefined, constant, derived,
  attached
} state;

typedef enum
{ times, modulo, divides,
  plus, minus, shift_left,
  shift_right, bitwise_and, bitwise_or,
  bitwise_xor, bitwise_not, int_times_int,
  real_times_real, int_times_text, int_plus_int,
  real_plus_real, text_plus_text, int_minus_int,
  real_minus_real
} operator;

/* Include imported defs */
#include <dcg_plist.h>
#include <proc_tree.h>
#include <affix_tree.h>

/* Introduce record nils */
#define module_nil ((module) NULL)
#define variable_nil ((variable) NULL)
#define export_nil ((export) NULL)
#define spec_nil ((spec) NULL)
#define psig_nil ((psig) NULL)
#define pdecl_nil ((pdecl) NULL)
#define proc_nil ((proc) NULL)
#define fpar_nil ((fpar) NULL)
#define group_nil ((group) NULL)
#define alternative_nil ((alternative) NULL)
#define member_nil ((member) NULL)
#define apar_nil ((apar) NULL)
#define affix_term_nil ((affix_term) NULL)
#define affix_rule_nil ((affix_rule) NULL)
#define affix_alternative_nil ((affix_alternative) NULL)
#define affix_element_nil ((affix_element) NULL)
#define call_arg_nil ((call_arg) NULL)
#define madm_nil ((madm) NULL)
#define assoc_pair_nil ((assoc_pair) NULL)
#define block_nil ((block) NULL)
#define instr_nil ((instr) NULL)
#define address_nil ((address) NULL)
#define altnr_label_pair_nil ((altnr_label_pair) NULL)
#define iexpr_nil ((iexpr) NULL)
#define rexpr_nil ((rexpr) NULL)

/* Introduce type_list nils */
#define module_list_nil ((module_list) NULL)
#define variable_list_nil ((variable_list) NULL)
#define export_list_nil ((export_list) NULL)
#define psig_list_nil ((psig_list) NULL)
#define pdecl_list_nil ((pdecl_list) NULL)
#define proc_list_nil ((proc_list) NULL)
#define fpar_list_nil ((fpar_list) NULL)
#define alternative_list_nil ((alternative_list) NULL)
#define member_list_nil ((member_list) NULL)
#define apar_list_nil ((apar_list) NULL)
#define affix_term_list_nil ((affix_term_list) NULL)
#define affix_rule_list_nil ((affix_rule_list) NULL)
#define affix_alternative_list_nil ((affix_alternative_list) NULL)
#define affix_element_list_nil ((affix_element_list) NULL)
#define call_arg_list_nil ((call_arg_list) NULL)
#define madm_list_nil ((madm_list) NULL)
#define state_list_nil ((state_list) NULL)
#define assoc_pair_list_nil ((assoc_pair_list) NULL)
#define block_list_nil ((block_list) NULL)
#define address_list_nil ((address_list) NULL)
#define altnr_label_pair_list_nil ((altnr_label_pair_list) NULL)
#define char_list_nil ((char_list) NULL)

/* Introduce enumeration nils */
#define proc_type_nil ((proc_type) 0)
#define dir_nil ((dir) 0)
#define guard_type_nil ((guard_type) 0)
#define flow_op_nil ((flow_op) 0)
#define state_nil ((state) 0)
#define operator_nil ((operator) 0)

/* introduce constructors */
#define Root_module u.ue_Root_module
#define Module u.ue_Module
#define Local_var u.ue_Local_var
#define Module_var u.ue_Module_var
#define Module_array u.ue_Module_array
#define Export_affix u.ue_Export_affix
#define Export_proc u.ue_Export_proc
#define Ext_proc u.ue_Ext_proc
#define Alts u.ue_Alts
#define Root u.ue_Root
#define Call u.ue_Call
#define Guard u.ue_Guard
#define Op u.ue_Op
#define Group u.ue_Group
#define Res_equal u.ue_Res_equal
#define Assign u.ue_Assign
#define Res_guard u.ue_Res_guard
#define Res_call u.ue_Res_call
#define Cast u.ue_Cast
#define Group_fail u.ue_Group_fail
#define Single u.ue_Single
#define Bidir u.ue_Bidir
#define Terminal u.ue_Terminal
#define Dyop u.ue_Dyop
#define Monop u.ue_Monop
#define Concat u.ue_Concat
#define Enclosed u.ue_Enclosed
#define Int u.ue_Int
#define Real u.ue_Real
#define Text u.ue_Text
#define Concr u.ue_Concr
#define Sub u.ue_Sub
#define Var u.ue_Var
#define Affix_synonym u.ue_Affix_synonym
#define Affix_import u.ue_Affix_import
#define Affix_alts u.ue_Affix_alts
#define Affix_abstr u.ue_Affix_abstr
#define Affix_prim u.ue_Affix_prim
#define Affix_var u.ue_Affix_var
#define Affix_term u.ue_Affix_term
#define Rule_adm u.ue_Rule_adm
#define Member_adm u.ue_Member_adm
#define Nop u.ue_Nop
#define Proc_entry u.ue_Proc_entry
#define Label u.ue_Label
#define Comment u.ue_Comment
#define Succeed u.ue_Succeed
#define Fail u.ue_Fail
#define Exit u.ue_Exit
#define Abort u.ue_Abort
#define Attach u.ue_Attach
#define Detach u.ue_Detach
#define Create u.ue_Create
#define Equal_altnr u.ue_Equal_altnr
#define Equal u.ue_Equal
#define Equal_int u.ue_Equal_int
#define Equal_real u.ue_Equal_real
#define Copy u.ue_Copy
#define Copy_int u.ue_Copy_int
#define Copy_real u.ue_Copy_real
#define Callp u.ue_Callp
#define Callf u.ue_Callf
#define Index u.ue_Index
#define Conc_text u.ue_Conc_text
#define Repl_text u.ue_Repl_text
#define Switch_altnr u.ue_Switch_altnr
#define Switch_int u.ue_Switch_int
#define Parameter u.ue_Parameter
#define Global u.ue_Global
#define Local u.ue_Local
#define Ilocal u.ue_Ilocal
#define Tconst u.ue_Tconst
#define Indirect u.ue_Indirect
#define Reference u.ue_Reference
#define Part u.ue_Part
#define Ivref u.ue_Ivref
#define Idyop u.ue_Idyop
#define Imonop u.ue_Imonop
#define Inum u.ue_Inum
#define Rvref u.ue_Rvref
#define Rdyop u.ue_Rdyop
#define Rmonop u.ue_Rmonop
#define Rnum u.ue_Rnum

/* Introduce constructor tags */
typedef enum en_tags_module
{ TAGRoot_module,
  TAGModule
} tags_module;

typedef enum en_tags_variable
{ TAGLocal_var,
  TAGModule_var,
  TAGModule_array
} tags_variable;

typedef enum en_tags_export
{ TAGExport_affix,
  TAGExport_proc
} tags_export;

typedef enum en_tags_proc
{ TAGExt_proc,
  TAGAlts,
  TAGRoot
} tags_proc;

typedef enum en_tags_member
{ TAGCall,
  TAGGuard,
  TAGOp,
  TAGGroup,
  TAGRes_equal,
  TAGAssign,
  TAGRes_guard,
  TAGRes_call,
  TAGCast,
  TAGGroup_fail
} tags_member;

typedef enum en_tags_apar
{ TAGSingle,
  TAGBidir
} tags_apar;

typedef enum en_tags_affix_term
{ TAGTerminal,
  TAGDyop,
  TAGMonop,
  TAGConcat,
  TAGEnclosed,
  TAGInt,
  TAGReal,
  TAGText,
  TAGConcr,
  TAGSub,
  TAGVar
} tags_affix_term;

typedef enum en_tags_affix_rule
{ TAGAffix_synonym,
  TAGAffix_import,
  TAGAffix_alts,
  TAGAffix_abstr,
  TAGAffix_prim
} tags_affix_rule;

typedef enum en_tags_affix_element
{ TAGAffix_var,
  TAGAffix_term
} tags_affix_element;

typedef enum en_tags_madm
{ TAGRule_adm,
  TAGMember_adm
} tags_madm;

typedef enum en_tags_instr
{ TAGNop,
  TAGProc_entry,
  TAGLabel,
  TAGComment,
  TAGSucceed,
  TAGFail,
  TAGExit,
  TAGAbort,
  TAGAttach,
  TAGDetach,
  TAGCreate,
  TAGEqual_altnr,
  TAGEqual,
  TAGEqual_int,
  TAGEqual_real,
  TAGCopy,
  TAGCopy_int,
  TAGCopy_real,
  TAGCallp,
  TAGCallf,
  TAGIndex,
  TAGConc_text,
  TAGRepl_text,
  TAGSwitch_altnr,
  TAGSwitch_int
} tags_instr;

typedef enum en_tags_address
{ TAGParameter,
  TAGGlobal,
  TAGLocal,
  TAGIlocal,
  TAGTconst,
  TAGIndirect,
  TAGReference,
  TAGPart
} tags_address;

typedef enum en_tags_iexpr
{ TAGIvref,
  TAGIdyop,
  TAGImonop,
  TAGInum
} tags_iexpr;

typedef enum en_tags_rexpr
{ TAGRvref,
  TAGRdyop,
  TAGRmonop,
  TAGRnum
} tags_rexpr;

/* Introduce structure for constructor Root_module */
typedef struct str_Root_module
{ string rname;
  export_list exports;
  proc prelude;
  proc root;
  proc postlude;
} C_Root_module;

/* Introduce structure for constructor Module_array */
typedef struct str_Module_array
{ affix_term size;
} C_Module_array;

/* Introduce structure for constructor Export_affix */
typedef struct str_Export_affix
{ string aname;
  affix_rule adef;
} C_Export_affix;

/* Introduce structure for constructor Export_proc */
typedef struct str_Export_proc
{ spec pspec;
  proc pdef;
  psig_list p1sig;
  psig_list p2sig;
} C_Export_proc;

/* Introduce structure for constructor Ext_proc */
typedef struct str_Ext_proc
{ string ename;
} C_Ext_proc;

/* Introduce structure for constructor Alts */
typedef struct str_Alts
{ group grp;
  int exported;
} C_Alts;

/* Introduce structure for constructor Root */
typedef struct str_Root
{ member_list mems;
} C_Root;

/* Introduce structure for constructor Call */
typedef struct str_Call
{ string_list pname_parts;
  int_list pname_chars;
  apar_list p1args;
  apar_list p2args;
} C_Call;

/* Introduce structure for constructor Guard */
typedef struct str_Guard
{ guard_type typ;
  affix_term_list lhs;
  affix_term_list rhs;
} C_Guard;

/* Introduce structure for constructor Op */
typedef struct str_Op
{ flow_op op;
} C_Op;

/* Introduce structure for constructor Group */
typedef struct str_Group
{ group grp;
} C_Group;

/* Introduce structure for constructor Res_equal */
typedef struct str_Res_equal
{ affix_term left;
  affix_term right;
} C_Res_equal;

/* Introduce structure for constructor Assign */
typedef struct str_Assign
{ affix_term src;
  affix_term dst;
} C_Assign;

/* Introduce structure for constructor Res_guard */
typedef struct str_Res_guard
{ guard_type typ;
  affix_term var;
  int altnr;
  int can_fail;
  affix_term_list expr;
} C_Res_guard;

/* Introduce structure for constructor Res_call */
typedef struct str_Res_call
{ proc pdef;
  affix_term_list p1args;
  affix_term_list p2args;
} C_Res_call;

/* Introduce structure for constructor Cast */
typedef struct str_Cast
{ affix_term term;
} C_Cast;

/* Introduce structure for constructor Single */
typedef struct str_Single
{ affix_term_list exp;
  affix_rule adef;
} C_Single;

/* Introduce structure for constructor Bidir */
typedef struct str_Bidir
{ affix_term_list exp1;
  affix_term_list exp2;
  affix_rule adef1;
  affix_rule adef2;
} C_Bidir;

/* Introduce structure for constructor Terminal */
typedef struct str_Terminal
{ string marker;
} C_Terminal;

/* Introduce structure for constructor Dyop */
typedef struct str_Dyop
{ operator dop;
  affix_term arg1;
  affix_term arg2;
} C_Dyop;

/* Introduce structure for constructor Monop */
typedef struct str_Monop
{ operator mop;
  affix_term arg;
} C_Monop;

/* Introduce structure for constructor Concat */
typedef struct str_Concat
{ affix_term_list terms;
} C_Concat;

/* Introduce structure for constructor Enclosed */
typedef struct str_Enclosed
{ affix_term_list terms;
} C_Enclosed;

/* Introduce structure for constructor Int */
typedef struct str_Int
{ int num;
} C_Int;

/* Introduce structure for constructor Real */
typedef struct str_Real
{ real num;
} C_Real;

/* Introduce structure for constructor Text */
typedef struct str_Text
{ string txt;
} C_Text;

/* Introduce structure for constructor Concr */
typedef struct str_Concr
{ affix_term abs;
} C_Concr;

/* Introduce structure for constructor Sub */
typedef struct str_Sub
{ string aname;
  affix_term index;
  variable vdef;
} C_Sub;

/* Introduce structure for constructor Var */
typedef struct str_Var
{ string aname;
  variable vdef;
} C_Var;

/* Introduce structure for constructor Affix_synonym */
typedef struct str_Affix_synonym
{ string syn;
  affix_rule syndef;
  affix_rule fin_repr;
} C_Affix_synonym;

/* Introduce structure for constructor Affix_import */
typedef struct str_Affix_import
{ module from;
  affix_rule impdef;
  affix_rule fin_repr;
} C_Affix_import;

/* Introduce structure for constructor Affix_alts */
typedef struct str_Affix_alts
{ affix_alternative_list alts;
  int enumerable;
} C_Affix_alts;

/* Introduce structure for constructor Affix_abstr */
typedef struct str_Affix_abstr
{ affix_alternative_list alts;
  affix_rule fin_repr;
} C_Affix_abstr;

/* Introduce structure for constructor Affix_var */
typedef struct str_Affix_var
{ string vname;
  affix_rule vdef;
} C_Affix_var;

/* Introduce structure for constructor Affix_term */
typedef struct str_Affix_term
{ string tname;
} C_Affix_term;

/* Introduce structure for constructor Rule_adm */
typedef struct str_Rule_adm
{ affix_term_list terms;
  int iptr;
  affix_rule goal;
  int complete;
} C_Rule_adm;

/* Introduce structure for constructor Member_adm */
typedef struct str_Member_adm
{ affix_rule arule;
  int alt_nr;
  int mem_nr;
} C_Member_adm;

/* Introduce structure for constructor Label */
typedef struct str_Label
{ int lnr;
} C_Label;

/* Introduce structure for constructor Comment */
typedef struct str_Comment
{ string text;
} C_Comment;

/* Introduce structure for constructor Abort */
typedef struct str_Abort
{ int mnr;
  int lnr;
} C_Abort;

/* Introduce structure for constructor Attach */
typedef struct str_Attach
{ address loc;
  int tnr;
} C_Attach;

/* Introduce structure for constructor Detach */
typedef struct str_Detach
{ address loc;
  int tnr;
} C_Detach;

/* Introduce structure for constructor Create */
typedef struct str_Create
{ int altnr;
  int size;
  address dst;
} C_Create;

/* Introduce structure for constructor Equal_altnr */
typedef struct str_Equal_altnr
{ address src;
  int altnr;
  int fail;
} C_Equal_altnr;

/* Introduce structure for constructor Equal */
typedef struct str_Equal
{ address src1;
  address src2;
  int tnr;
  int fail;
} C_Equal;

/* Introduce structure for constructor Equal_int */
typedef struct str_Equal_int
{ address src;
  iexpr cmp;
  int fail;
} C_Equal_int;

/* Introduce structure for constructor Equal_real */
typedef struct str_Equal_real
{ address src;
  rexpr cmp;
  int fail;
} C_Equal_real;

/* Introduce structure for constructor Copy */
typedef struct str_Copy
{ address src;
  address dst;
} C_Copy;

/* Introduce structure for constructor Copy_int */
typedef struct str_Copy_int
{ iexpr src;
  address dst;
} C_Copy_int;

/* Introduce structure for constructor Copy_real */
typedef struct str_Copy_real
{ rexpr src;
  address dst;
} C_Copy_real;

/* Introduce structure for constructor Callp */
typedef struct str_Callp
{ int pnr;
  address_list args;
} C_Callp;

/* Introduce structure for constructor Callf */
typedef struct str_Callf
{ int pnr;
  address_list args;
  int fail;
} C_Callf;

/* Introduce structure for constructor Index */
typedef struct str_Index
{ address glb;
  iexpr idx;
  address iloc;
} C_Index;

/* Introduce structure for constructor Conc_text */
typedef struct str_Conc_text
{ address_list srcs;
  address dst;
} C_Conc_text;

/* Introduce structure for constructor Repl_text */
typedef struct str_Repl_text
{ iexpr fac;
  address src;
  address dst;
} C_Repl_text;

/* Introduce structure for constructor Switch_altnr */
typedef struct str_Switch_altnr
{ address src;
  altnr_label_pair_list cases;
  int fail;
} C_Switch_altnr;

/* Introduce structure for constructor Switch_int */
typedef struct str_Switch_int
{ address src;
  altnr_label_pair_list cases;
  int fail;
} C_Switch_int;

/* Introduce structure for constructor Parameter */
typedef struct str_Parameter
{ int pnr;
} C_Parameter;

/* Introduce structure for constructor Global */
typedef struct str_Global
{ int gnr;
} C_Global;

/* Introduce structure for constructor Local */
typedef struct str_Local
{ int lnr;
} C_Local;

/* Introduce structure for constructor Ilocal */
typedef struct str_Ilocal
{ int inr;
} C_Ilocal;

/* Introduce structure for constructor Tconst */
typedef struct str_Tconst
{ int cnr;
} C_Tconst;

/* Introduce structure for constructor Indirect */
typedef struct str_Indirect
{ address adr;
} C_Indirect;

/* Introduce structure for constructor Reference */
typedef struct str_Reference
{ address adr;
} C_Reference;

/* Introduce structure for constructor Part */
typedef struct str_Part
{ address adr;
  int idx;
} C_Part;

/* Introduce structure for constructor Ivref */
typedef struct str_Ivref
{ address adr;
} C_Ivref;

/* Introduce structure for constructor Idyop */
typedef struct str_Idyop
{ operator dop;
  iexpr src1;
  iexpr src2;
} C_Idyop;

/* Introduce structure for constructor Imonop */
typedef struct str_Imonop
{ operator mop;
  iexpr src;
} C_Imonop;

/* Introduce structure for constructor Inum */
typedef struct str_Inum
{ int num;
} C_Inum;

/* Introduce structure for constructor Rvref */
typedef struct str_Rvref
{ address adr;
} C_Rvref;

/* Introduce structure for constructor Rdyop */
typedef struct str_Rdyop
{ operator dop;
  rexpr src1;
  rexpr src2;
} C_Rdyop;

/* Introduce structure for constructor Rmonop */
typedef struct str_Rmonop
{ operator mop;
  rexpr src;
} C_Rmonop;

/* Introduce structure for constructor Rnum */
typedef struct str_Rnum
{ real num;
} C_Rnum;

/* Introduce structure of type module */
struct str_module
{ string fname;
  string mname;
  variable_list mvars;
  export_list defines;
  string_list uses;
  proc_list procs;
  affix_rule_list arules;
  int mnr;
  proc_tree pdefs;
  affix_tree adefs;
  proc_list preludes;
  proc_list interludes;
  proc_list postludes;
  tags_module tag;
  union uni_module
    { C_Root_module ue_Root_module;
    } u;
};

/* Introduce structure of type variable */
struct str_variable
{ string vname;
  affix_rule adef;
  int nr;
  int dont_code;
  tags_variable tag;
  union uni_variable
    { C_Module_array ue_Module_array;
    } u;
};

/* Introduce structure of type export */
struct str_export
{ int line;
  int col;
  tags_export tag;
  union uni_export
    { C_Export_affix ue_Export_affix;
      C_Export_proc ue_Export_proc;
    } u;
};

/* Introduce structure of type spec */
struct str_spec
{ int line;
  int col;
  proc_type ptype;
  string_list pname_parts;
  int_list pname_chars;
  fpar_list p1fpars;
  fpar_list p2fpars;
  string canonic_name;
  string concat_name;
  proc_type real_ptype;
};

/* Introduce structure of type psig */
struct str_psig
{ affix_rule ftyp;
  dir fdir;
};

/* Introduce structure of type pdecl */
struct str_pdecl
{ psig_list p1sig;
  psig_list p2sig;
  proc pdef;
};

/* Introduce structure of type proc */
struct str_proc
{ spec pspec;
  int pnr;
  int mnr;
  int called;
  int concat_size;
  variable_list pvars;
  int ivars;
  block_list bbs;
  tags_proc tag;
  union uni_proc
    { C_Ext_proc ue_Ext_proc;
      C_Alts ue_Alts;
      C_Root ue_Root;
    } u;
};

/* Introduce structure of type fpar */
struct str_fpar
{ int line;
  int col;
  string fname;
  dir fdir;
  variable fdef;
};

/* Introduce structure of type group */
struct str_group
{ alternative_list alts;
  block start;
  state_list visibility;
};

/* Introduce structure of type alternative */
struct str_alternative
{ member_list p1mems;
  member_list p2mems;
  assoc_pair_list recovery;
  state_list init_visibility;
};

/* Introduce structure of type member */
struct str_member
{ int line;
  int col;
  member true_succ;
  member false_succ;
  member_list pred;
  tags_member tag;
  union uni_member
    { C_Call ue_Call;
      C_Guard ue_Guard;
      C_Op ue_Op;
      C_Group ue_Group;
      C_Res_equal ue_Res_equal;
      C_Assign ue_Assign;
      C_Res_guard ue_Res_guard;
      C_Res_call ue_Res_call;
      C_Cast ue_Cast;
    } u;
};

/* Introduce structure of type apar */
struct str_apar
{ tags_apar tag;
  union uni_apar
    { C_Single ue_Single;
      C_Bidir ue_Bidir;
    } u;
};

/* Introduce structure of type affix_term */
struct str_affix_term
{ int line;
  int col;
  affix_rule adef;
  tags_affix_term tag;
  union uni_affix_term
    { C_Terminal ue_Terminal;
      C_Dyop ue_Dyop;
      C_Monop ue_Monop;
      C_Concat ue_Concat;
      C_Enclosed ue_Enclosed;
      C_Int ue_Int;
      C_Real ue_Real;
      C_Text ue_Text;
      C_Concr ue_Concr;
      C_Sub ue_Sub;
      C_Var ue_Var;
    } u;
};

/* Introduce structure of type affix_rule */
struct str_affix_rule
{ int line;
  int col;
  string aname;
  int anr;
  int mnr;
  int_list lc_nrs;
  int needs_gc;
  int exported;
  int no_equal;
  int no_write;
  tags_affix_rule tag;
  union uni_affix_rule
    { C_Affix_synonym ue_Affix_synonym;
      C_Affix_import ue_Affix_import;
      C_Affix_alts ue_Affix_alts;
      C_Affix_abstr ue_Affix_abstr;
    } u;
};

/* Introduce structure of type affix_alternative */
struct str_affix_alternative
{ affix_element_list elems;
};

/* Introduce structure of type affix_element */
struct str_affix_element
{ int line;
  int col;
  tags_affix_element tag;
  union uni_affix_element
    { C_Affix_var ue_Affix_var;
      C_Affix_term ue_Affix_term;
    } u;
};

/* Introduce structure of type call_arg */
struct str_call_arg
{ affix_term inh_term;
  member_list inh_guards;
  affix_term der_term;
  member_list der_guards;
};

/* Introduce structure of type madm */
struct str_madm
{ tags_madm tag;
  union uni_madm
    { C_Rule_adm ue_Rule_adm;
      C_Member_adm ue_Member_adm;
    } u;
};

/* Introduce structure of type assoc_pair */
struct str_assoc_pair
{ int lnr;
  int auxnr;
};

/* Introduce structure of type block */
struct str_block
{ instr head;
  instr tail;
  block_list pred;
  block_list true_succ;
  block false_succ;
  state_list visibility;
  int dont_code;
  char_list in;
  char_list use;
  char_list gen;
  char_list out;
  char_list callf_gen;
  char_list callf_use;
};

/* Introduce structure of type instr */
struct str_instr
{ instr prev;
  instr next;
  int dont_code;
  tags_instr tag;
  union uni_instr
    { C_Label ue_Label;
      C_Comment ue_Comment;
      C_Abort ue_Abort;
      C_Attach ue_Attach;
      C_Detach ue_Detach;
      C_Create ue_Create;
      C_Equal_altnr ue_Equal_altnr;
      C_Equal ue_Equal;
      C_Equal_int ue_Equal_int;
      C_Equal_real ue_Equal_real;
      C_Copy ue_Copy;
      C_Copy_int ue_Copy_int;
      C_Copy_real ue_Copy_real;
      C_Callp ue_Callp;
      C_Callf ue_Callf;
      C_Index ue_Index;
      C_Conc_text ue_Conc_text;
      C_Repl_text ue_Repl_text;
      C_Switch_altnr ue_Switch_altnr;
      C_Switch_int ue_Switch_int;
    } u;
};

/* Introduce structure of type address */
struct str_address
{ tags_address tag;
  union uni_address
    { C_Parameter ue_Parameter;
      C_Global ue_Global;
      C_Local ue_Local;
      C_Ilocal ue_Ilocal;
      C_Tconst ue_Tconst;
      C_Indirect ue_Indirect;
      C_Reference ue_Reference;
      C_Part ue_Part;
    } u;
};

/* Introduce structure of type altnr_label_pair */
struct str_altnr_label_pair
{ int altnr;
  int lnr;
};

/* Introduce structure of type iexpr */
struct str_iexpr
{ tags_iexpr tag;
  union uni_iexpr
    { C_Ivref ue_Ivref;
      C_Idyop ue_Idyop;
      C_Imonop ue_Imonop;
      C_Inum ue_Inum;
    } u;
};

/* Introduce structure of type rexpr */
struct str_rexpr
{ tags_rexpr tag;
  union uni_rexpr
    { C_Rvref ue_Rvref;
      C_Rdyop ue_Rdyop;
      C_Rmonop ue_Rmonop;
      C_Rnum ue_Rnum;
    } u;
};

/* Introduce structure of type module_list */
struct str_module_list
{ int size;
  int room;
  module *array;
};

/* Introduce structure of type variable_list */
struct str_variable_list
{ int size;
  int room;
  variable *array;
};

/* Introduce structure of type export_list */
struct str_export_list
{ int size;
  int room;
  export *array;
};

/* Introduce structure of type psig_list */
struct str_psig_list
{ int size;
  int room;
  psig *array;
};

/* Introduce structure of type pdecl_list */
struct str_pdecl_list
{ int size;
  int room;
  pdecl *array;
};

/* Introduce structure of type proc_list */
struct str_proc_list
{ int size;
  int room;
  proc *array;
};

/* Introduce structure of type fpar_list */
struct str_fpar_list
{ int size;
  int room;
  fpar *array;
};

/* Introduce structure of type alternative_list */
struct str_alternative_list
{ int size;
  int room;
  alternative *array;
};

/* Introduce structure of type member_list */
struct str_member_list
{ int size;
  int room;
  member *array;
};

/* Introduce structure of type apar_list */
struct str_apar_list
{ int size;
  int room;
  apar *array;
};

/* Introduce structure of type affix_term_list */
struct str_affix_term_list
{ int size;
  int room;
  affix_term *array;
};

/* Introduce structure of type affix_rule_list */
struct str_affix_rule_list
{ int size;
  int room;
  affix_rule *array;
};

/* Introduce structure of type affix_alternative_list */
struct str_affix_alternative_list
{ int size;
  int room;
  affix_alternative *array;
};

/* Introduce structure of type affix_element_list */
struct str_affix_element_list
{ int size;
  int room;
  affix_element *array;
};

/* Introduce structure of type call_arg_list */
struct str_call_arg_list
{ int size;
  int room;
  call_arg *array;
};

/* Introduce structure of type madm_list */
struct str_madm_list
{ int size;
  int room;
  madm *array;
};

/* Introduce structure of type state_list */
struct str_state_list
{ int size;
  int room;
  state *array;
};

/* Introduce structure of type assoc_pair_list */
struct str_assoc_pair_list
{ int size;
  int room;
  assoc_pair *array;
};

/* Introduce structure of type block_list */
struct str_block_list
{ int size;
  int room;
  block *array;
};

/* Introduce structure of type address_list */
struct str_address_list
{ int size;
  int room;
  address *array;
};

/* Introduce structure of type altnr_label_pair_list */
struct str_altnr_label_pair_list
{ int size;
  int room;
  altnr_label_pair *array;
};

/* Introduce structure of type char_list */
struct str_char_list
{ int size;
  int room;
  char *array;
};

/* Introduce list allocation routines */
module_list init_module_list (int room);
variable_list init_variable_list (int room);
export_list init_export_list (int room);
psig_list init_psig_list (int room);
pdecl_list init_pdecl_list (int room);
proc_list init_proc_list (int room);
fpar_list init_fpar_list (int room);
alternative_list init_alternative_list (int room);
member_list init_member_list (int room);
apar_list init_apar_list (int room);
affix_term_list init_affix_term_list (int room);
affix_rule_list init_affix_rule_list (int room);
affix_alternative_list init_affix_alternative_list (int room);
affix_element_list init_affix_element_list (int room);
call_arg_list init_call_arg_list (int room);
madm_list init_madm_list (int room);
state_list init_state_list (int room);
assoc_pair_list init_assoc_pair_list (int room);
block_list init_block_list (int room);
address_list init_address_list (int room);
altnr_label_pair_list init_altnr_label_pair_list (int room);
char_list init_char_list (int room);

/* Introduce room allocation routines */
void room_module_list (module_list l, int room);
void room_variable_list (variable_list l, int room);
void room_export_list (export_list l, int room);
void room_psig_list (psig_list l, int room);
void room_pdecl_list (pdecl_list l, int room);
void room_proc_list (proc_list l, int room);
void room_fpar_list (fpar_list l, int room);
void room_alternative_list (alternative_list l, int room);
void room_member_list (member_list l, int room);
void room_apar_list (apar_list l, int room);
void room_affix_term_list (affix_term_list l, int room);
void room_affix_rule_list (affix_rule_list l, int room);
void room_affix_alternative_list (affix_alternative_list l, int room);
void room_affix_element_list (affix_element_list l, int room);
void room_call_arg_list (call_arg_list l, int room);
void room_madm_list (madm_list l, int room);
void room_state_list (state_list l, int room);
void room_assoc_pair_list (assoc_pair_list l, int room);
void room_block_list (block_list l, int room);
void room_address_list (address_list l, int room);
void room_altnr_label_pair_list (altnr_label_pair_list l, int room);
void room_char_list (char_list l, int room);

/* Introduce list allocation shorthands */
#define new_module_list() init_module_list(2)
#define new_variable_list() init_variable_list(2)
#define new_export_list() init_export_list(2)
#define new_psig_list() init_psig_list(2)
#define new_pdecl_list() init_pdecl_list(2)
#define new_proc_list() init_proc_list(2)
#define new_fpar_list() init_fpar_list(2)
#define new_alternative_list() init_alternative_list(2)
#define new_member_list() init_member_list(2)
#define new_apar_list() init_apar_list(2)
#define new_affix_term_list() init_affix_term_list(2)
#define new_affix_rule_list() init_affix_rule_list(2)
#define new_affix_alternative_list() init_affix_alternative_list(2)
#define new_affix_element_list() init_affix_element_list(2)
#define new_call_arg_list() init_call_arg_list(2)
#define new_madm_list() init_madm_list(2)
#define new_state_list() init_state_list(2)
#define new_assoc_pair_list() init_assoc_pair_list(2)
#define new_block_list() init_block_list(2)
#define new_address_list() init_address_list(2)
#define new_altnr_label_pair_list() init_altnr_label_pair_list(2)
#define new_char_list() init_char_list(2)

/* Introduce type allocation routines */
module new_Root_module (string fname, string mname, variable_list mvars, export_list defines, string_list uses, proc_list procs, affix_rule_list arules,
		string rname, export_list exports);
module new_Module (string fname, string mname, variable_list mvars, export_list defines, string_list uses, proc_list procs, affix_rule_list arules);
variable new_Local_var (string vname);
variable new_Module_var (string vname);
variable new_Module_array (string vname,
		affix_term size);
export new_Export_affix (int line, int col,
		string aname);
export new_Export_proc (int line, int col,
		spec pspec);
spec new_spec (int line, int col, proc_type ptype, string_list pname_parts, int_list pname_chars, fpar_list p1fpars, fpar_list p2fpars, string canonic_name, string concat_name, proc_type real_ptype);
psig new_psig ();
pdecl new_pdecl ();
proc new_Ext_proc (spec pspec,
		string ename);
proc new_Alts (spec pspec,
		group grp);
proc new_Root (spec pspec,
		member_list mems);
fpar new_fpar (int line, int col, string fname, dir fdir);
group new_group (alternative_list alts);
alternative new_alternative (member_list p1mems, member_list p2mems);
member new_Call (int line, int col,
		string_list pname_parts, int_list pname_chars, apar_list p1args, apar_list p2args);
member new_Guard (int line, int col,
		guard_type typ, affix_term_list lhs, affix_term_list rhs);
member new_Op (int line, int col,
		flow_op op);
member new_Group (int line, int col,
		group grp);
member new_Res_equal (int line, int col,
		affix_term left, affix_term right);
member new_Assign (int line, int col,
		affix_term src, affix_term dst);
member new_Res_guard (int line, int col,
		guard_type typ, affix_term var, int altnr, int can_fail, affix_term_list expr);
member new_Res_call (int line, int col,
		affix_term_list p1args, affix_term_list p2args);
member new_Cast (int line, int col,
		affix_term term);
member new_Group_fail (int line, int col);
apar new_Single (affix_term_list exp);
apar new_Bidir (affix_term_list exp1, affix_term_list exp2);
affix_term new_Terminal (int line, int col,
		string marker);
affix_term new_Dyop (int line, int col,
		operator dop, affix_term arg1, affix_term arg2);
affix_term new_Monop (int line, int col,
		operator mop, affix_term arg);
affix_term new_Concat (int line, int col,
		affix_term_list terms);
affix_term new_Enclosed (int line, int col,
		affix_term_list terms);
affix_term new_Int (int line, int col,
		int num);
affix_term new_Real (int line, int col,
		real num);
affix_term new_Text (int line, int col,
		string txt);
affix_term new_Concr (int line, int col,
		affix_term abs);
affix_term new_Sub (int line, int col,
		string aname, affix_term index);
affix_term new_Var (int line, int col,
		string aname);
affix_rule new_Affix_synonym (int line, int col, string aname,
		string syn);
affix_rule new_Affix_import (int line, int col, string aname);
affix_rule new_Affix_alts (int line, int col, string aname,
		affix_alternative_list alts);
affix_rule new_Affix_abstr (int line, int col, string aname,
		affix_alternative_list alts);
affix_rule new_Affix_prim (int line, int col, string aname);
affix_alternative new_affix_alternative (affix_element_list elems);
affix_element new_Affix_var (int line, int col,
		string vname);
affix_element new_Affix_term (int line, int col,
		string tname);
call_arg new_call_arg ();
madm new_Rule_adm ();
madm new_Member_adm (int alt_nr, int mem_nr);
assoc_pair new_assoc_pair (int lnr, int auxnr);
block new_block ();
instr new_Nop ();
instr new_Proc_entry ();
instr new_Label (int lnr);
instr new_Comment (string text);
instr new_Succeed ();
instr new_Fail ();
instr new_Exit ();
instr new_Abort (int mnr, int lnr);
instr new_Attach (address loc, int tnr);
instr new_Detach (address loc, int tnr);
instr new_Create (int altnr, int size, address dst);
instr new_Equal_altnr (address src, int altnr, int fail);
instr new_Equal (address src1, address src2, int tnr, int fail);
instr new_Equal_int (address src, iexpr cmp, int fail);
instr new_Equal_real (address src, rexpr cmp, int fail);
instr new_Copy (address src, address dst);
instr new_Copy_int (iexpr src, address dst);
instr new_Copy_real (rexpr src, address dst);
instr new_Callp (int pnr, address_list args);
instr new_Callf (int pnr, address_list args, int fail);
instr new_Index (address glb, iexpr idx, address iloc);
instr new_Conc_text (address_list srcs, address dst);
instr new_Repl_text (iexpr fac, address src, address dst);
instr new_Switch_altnr (address src, altnr_label_pair_list cases, int fail);
instr new_Switch_int (address src, altnr_label_pair_list cases, int fail);
address new_Parameter (int pnr);
address new_Global (int gnr);
address new_Local (int lnr);
address new_Ilocal (int inr);
address new_Tconst (int cnr);
address new_Indirect (address adr);
address new_Reference (address adr);
address new_Part (address adr, int idx);
altnr_label_pair new_altnr_label_pair (int altnr, int lnr);
iexpr new_Ivref (address adr);
iexpr new_Idyop (operator dop, iexpr src1, iexpr src2);
iexpr new_Imonop (operator mop, iexpr src);
iexpr new_Inum (int num);
rexpr new_Rvref (address adr);
rexpr new_Rdyop (operator dop, rexpr src1, rexpr src2);
rexpr new_Rmonop (operator mop, rexpr src);
rexpr new_Rnum (real num);

/* Introduce attaching of types */
#define attach_module(orig)(module) dcg_attach ((char *) orig)
#define att_module(orig)(void) dcg_attach ((char *) orig)
#define attach_variable(orig)(variable) dcg_attach ((char *) orig)
#define att_variable(orig)(void) dcg_attach ((char *) orig)
#define attach_export(orig)(export) dcg_attach ((char *) orig)
#define att_export(orig)(void) dcg_attach ((char *) orig)
#define attach_spec(orig)(spec) dcg_attach ((char *) orig)
#define att_spec(orig)(void) dcg_attach ((char *) orig)
#define attach_psig(orig)(psig) dcg_attach ((char *) orig)
#define att_psig(orig)(void) dcg_attach ((char *) orig)
#define attach_pdecl(orig)(pdecl) dcg_attach ((char *) orig)
#define att_pdecl(orig)(void) dcg_attach ((char *) orig)
#define attach_proc(orig)(proc) dcg_attach ((char *) orig)
#define att_proc(orig)(void) dcg_attach ((char *) orig)
#define attach_proc_type(orig) (orig)
#define att_proc_type(orig)
#define attach_fpar(orig)(fpar) dcg_attach ((char *) orig)
#define att_fpar(orig)(void) dcg_attach ((char *) orig)
#define attach_dir(orig) (orig)
#define att_dir(orig)
#define attach_group(orig)(group) dcg_attach ((char *) orig)
#define att_group(orig)(void) dcg_attach ((char *) orig)
#define attach_alternative(orig)(alternative) dcg_attach ((char *) orig)
#define att_alternative(orig)(void) dcg_attach ((char *) orig)
#define attach_member(orig)(member) dcg_attach ((char *) orig)
#define att_member(orig)(void) dcg_attach ((char *) orig)
#define attach_apar(orig)(apar) dcg_attach ((char *) orig)
#define att_apar(orig)(void) dcg_attach ((char *) orig)
#define attach_guard_type(orig) (orig)
#define att_guard_type(orig)
#define attach_flow_op(orig) (orig)
#define att_flow_op(orig)
#define attach_affix_term(orig)(affix_term) dcg_attach ((char *) orig)
#define att_affix_term(orig)(void) dcg_attach ((char *) orig)
#define attach_affix_rule(orig)(affix_rule) dcg_attach ((char *) orig)
#define att_affix_rule(orig)(void) dcg_attach ((char *) orig)
#define attach_affix_alternative(orig)(affix_alternative) dcg_attach ((char *) orig)
#define att_affix_alternative(orig)(void) dcg_attach ((char *) orig)
#define attach_affix_element(orig)(affix_element) dcg_attach ((char *) orig)
#define att_affix_element(orig)(void) dcg_attach ((char *) orig)
#define attach_call_arg(orig)(call_arg) dcg_attach ((char *) orig)
#define att_call_arg(orig)(void) dcg_attach ((char *) orig)
#define attach_madm(orig)(madm) dcg_attach ((char *) orig)
#define att_madm(orig)(void) dcg_attach ((char *) orig)
#define attach_state(orig) (orig)
#define att_state(orig)
#define attach_assoc_pair(orig)(assoc_pair) dcg_attach ((char *) orig)
#define att_assoc_pair(orig)(void) dcg_attach ((char *) orig)
#define attach_block(orig)(block) dcg_attach ((char *) orig)
#define att_block(orig)(void) dcg_attach ((char *) orig)
#define attach_instr(orig)(instr) dcg_attach ((char *) orig)
#define att_instr(orig)(void) dcg_attach ((char *) orig)
#define attach_address(orig)(address) dcg_attach ((char *) orig)
#define att_address(orig)(void) dcg_attach ((char *) orig)
#define attach_altnr_label_pair(orig)(altnr_label_pair) dcg_attach ((char *) orig)
#define att_altnr_label_pair(orig)(void) dcg_attach ((char *) orig)
#define attach_iexpr(orig)(iexpr) dcg_attach ((char *) orig)
#define att_iexpr(orig)(void) dcg_attach ((char *) orig)
#define attach_rexpr(orig)(rexpr) dcg_attach ((char *) orig)
#define att_rexpr(orig)(void) dcg_attach ((char *) orig)
#define attach_operator(orig) (orig)
#define att_operator(orig)

/* Introduce attaching of lists */
#define attach_module_list(orig) (module_list) dcg_attach ((char *) orig)
#define att_module_list(orig) (void) dcg_attach ((char *) orig)
#define attach_variable_list(orig) (variable_list) dcg_attach ((char *) orig)
#define att_variable_list(orig) (void) dcg_attach ((char *) orig)
#define attach_export_list(orig) (export_list) dcg_attach ((char *) orig)
#define att_export_list(orig) (void) dcg_attach ((char *) orig)
#define attach_psig_list(orig) (psig_list) dcg_attach ((char *) orig)
#define att_psig_list(orig) (void) dcg_attach ((char *) orig)
#define attach_pdecl_list(orig) (pdecl_list) dcg_attach ((char *) orig)
#define att_pdecl_list(orig) (void) dcg_attach ((char *) orig)
#define attach_proc_list(orig) (proc_list) dcg_attach ((char *) orig)
#define att_proc_list(orig) (void) dcg_attach ((char *) orig)
#define attach_fpar_list(orig) (fpar_list) dcg_attach ((char *) orig)
#define att_fpar_list(orig) (void) dcg_attach ((char *) orig)
#define attach_alternative_list(orig) (alternative_list) dcg_attach ((char *) orig)
#define att_alternative_list(orig) (void) dcg_attach ((char *) orig)
#define attach_member_list(orig) (member_list) dcg_attach ((char *) orig)
#define att_member_list(orig) (void) dcg_attach ((char *) orig)
#define attach_apar_list(orig) (apar_list) dcg_attach ((char *) orig)
#define att_apar_list(orig) (void) dcg_attach ((char *) orig)
#define attach_affix_term_list(orig) (affix_term_list) dcg_attach ((char *) orig)
#define att_affix_term_list(orig) (void) dcg_attach ((char *) orig)
#define attach_affix_rule_list(orig) (affix_rule_list) dcg_attach ((char *) orig)
#define att_affix_rule_list(orig) (void) dcg_attach ((char *) orig)
#define attach_affix_alternative_list(orig) (affix_alternative_list) dcg_attach ((char *) orig)
#define att_affix_alternative_list(orig) (void) dcg_attach ((char *) orig)
#define attach_affix_element_list(orig) (affix_element_list) dcg_attach ((char *) orig)
#define att_affix_element_list(orig) (void) dcg_attach ((char *) orig)
#define attach_call_arg_list(orig) (call_arg_list) dcg_attach ((char *) orig)
#define att_call_arg_list(orig) (void) dcg_attach ((char *) orig)
#define attach_madm_list(orig) (madm_list) dcg_attach ((char *) orig)
#define att_madm_list(orig) (void) dcg_attach ((char *) orig)
#define attach_state_list(orig) (state_list) dcg_attach ((char *) orig)
#define att_state_list(orig) (void) dcg_attach ((char *) orig)
#define attach_assoc_pair_list(orig) (assoc_pair_list) dcg_attach ((char *) orig)
#define att_assoc_pair_list(orig) (void) dcg_attach ((char *) orig)
#define attach_block_list(orig) (block_list) dcg_attach ((char *) orig)
#define att_block_list(orig) (void) dcg_attach ((char *) orig)
#define attach_address_list(orig) (address_list) dcg_attach ((char *) orig)
#define att_address_list(orig) (void) dcg_attach ((char *) orig)
#define attach_altnr_label_pair_list(orig) (altnr_label_pair_list) dcg_attach ((char *) orig)
#define att_altnr_label_pair_list(orig) (void) dcg_attach ((char *) orig)
#define attach_char_list(orig) (char_list) dcg_attach ((char *) orig)
#define att_char_list(orig) (void) dcg_attach ((char *) orig)

/* Introduce detaching of enumeration types */
#define detach_proc_type(old)
#define det_proc_type(old)
#define detach_dir(old)
#define det_dir(old)
#define detach_guard_type(old)
#define det_guard_type(old)
#define detach_flow_op(old)
#define det_flow_op(old)
#define detach_state(old)
#define det_state(old)
#define detach_operator(old)
#define det_operator(old)

/* Introduce detaching of record types */
void detach_module (module *optr);
#define det_module(optr) detach_module(optr)
void detach_variable (variable *optr);
#define det_variable(optr) detach_variable(optr)
void detach_export (export *optr);
#define det_export(optr) detach_export(optr)
void detach_spec (spec *optr);
#define det_spec(optr) detach_spec(optr)
void detach_psig (psig *optr);
#define det_psig(optr) detach_psig(optr)
void detach_pdecl (pdecl *optr);
#define det_pdecl(optr) detach_pdecl(optr)
void detach_proc (proc *optr);
#define det_proc(optr) detach_proc(optr)
void detach_fpar (fpar *optr);
#define det_fpar(optr) detach_fpar(optr)
void detach_group (group *optr);
#define det_group(optr) detach_group(optr)
void detach_alternative (alternative *optr);
#define det_alternative(optr) detach_alternative(optr)
void detach_member (member *optr);
#define det_member(optr) detach_member(optr)
void detach_apar (apar *optr);
#define det_apar(optr) detach_apar(optr)
void detach_affix_term (affix_term *optr);
#define det_affix_term(optr) detach_affix_term(optr)
void detach_affix_rule (affix_rule *optr);
#define det_affix_rule(optr) detach_affix_rule(optr)
void detach_affix_alternative (affix_alternative *optr);
#define det_affix_alternative(optr) detach_affix_alternative(optr)
void detach_affix_element (affix_element *optr);
#define det_affix_element(optr) detach_affix_element(optr)
void detach_call_arg (call_arg *optr);
#define det_call_arg(optr) detach_call_arg(optr)
void detach_madm (madm *optr);
#define det_madm(optr) detach_madm(optr)
void detach_assoc_pair (assoc_pair *optr);
#define det_assoc_pair(optr) detach_assoc_pair(optr)
void detach_block (block *optr);
#define det_block(optr) detach_block(optr)
void detach_instr (instr *optr);
#define det_instr(optr) detach_instr(optr)
void detach_address (address *optr);
#define det_address(optr) detach_address(optr)
void detach_altnr_label_pair (altnr_label_pair *optr);
#define det_altnr_label_pair(optr) detach_altnr_label_pair(optr)
void detach_iexpr (iexpr *optr);
#define det_iexpr(optr) detach_iexpr(optr)
void detach_rexpr (rexpr *optr);
#define det_rexpr(optr) detach_rexpr(optr)

/* Introduce detaching of lists */
void detach_module_list (module_list *lp);
void detach_variable_list (variable_list *lp);
void detach_export_list (export_list *lp);
void detach_psig_list (psig_list *lp);
void detach_pdecl_list (pdecl_list *lp);
void detach_proc_list (proc_list *lp);
void detach_fpar_list (fpar_list *lp);
void detach_alternative_list (alternative_list *lp);
void detach_member_list (member_list *lp);
void detach_apar_list (apar_list *lp);
void detach_affix_term_list (affix_term_list *lp);
void detach_affix_rule_list (affix_rule_list *lp);
void detach_affix_alternative_list (affix_alternative_list *lp);
void detach_affix_element_list (affix_element_list *lp);
void detach_call_arg_list (call_arg_list *lp);
void detach_madm_list (madm_list *lp);
void detach_state_list (state_list *lp);
void detach_assoc_pair_list (assoc_pair_list *lp);
void detach_block_list (block_list *lp);
void detach_address_list (address_list *lp);
void detach_altnr_label_pair_list (altnr_label_pair_list *lp);
void detach_char_list (char_list *lp);

/* Introduce nonrecursive detaching of lists */
void nonrec_detach_module_list (module_list *lp);
void nonrec_detach_variable_list (variable_list *lp);
void nonrec_detach_export_list (export_list *lp);
void nonrec_detach_psig_list (psig_list *lp);
void nonrec_detach_pdecl_list (pdecl_list *lp);
void nonrec_detach_proc_list (proc_list *lp);
void nonrec_detach_fpar_list (fpar_list *lp);
void nonrec_detach_alternative_list (alternative_list *lp);
void nonrec_detach_member_list (member_list *lp);
void nonrec_detach_apar_list (apar_list *lp);
void nonrec_detach_affix_term_list (affix_term_list *lp);
void nonrec_detach_affix_rule_list (affix_rule_list *lp);
void nonrec_detach_affix_alternative_list (affix_alternative_list *lp);
void nonrec_detach_affix_element_list (affix_element_list *lp);
void nonrec_detach_call_arg_list (call_arg_list *lp);
void nonrec_detach_madm_list (madm_list *lp);
void nonrec_detach_state_list (state_list *lp);
void nonrec_detach_assoc_pair_list (assoc_pair_list *lp);
void nonrec_detach_block_list (block_list *lp);
void nonrec_detach_address_list (address_list *lp);
void nonrec_detach_altnr_label_pair_list (altnr_label_pair_list *lp);
void nonrec_detach_char_list (char_list *lp);

/* Introduce list append routines */
module_list append_module_list (module_list l, module el);
variable_list append_variable_list (variable_list l, variable el);
export_list append_export_list (export_list l, export el);
psig_list append_psig_list (psig_list l, psig el);
pdecl_list append_pdecl_list (pdecl_list l, pdecl el);
proc_list append_proc_list (proc_list l, proc el);
fpar_list append_fpar_list (fpar_list l, fpar el);
alternative_list append_alternative_list (alternative_list l, alternative el);
member_list append_member_list (member_list l, member el);
apar_list append_apar_list (apar_list l, apar el);
affix_term_list append_affix_term_list (affix_term_list l, affix_term el);
affix_rule_list append_affix_rule_list (affix_rule_list l, affix_rule el);
affix_alternative_list append_affix_alternative_list (affix_alternative_list l, affix_alternative el);
affix_element_list append_affix_element_list (affix_element_list l, affix_element el);
call_arg_list append_call_arg_list (call_arg_list l, call_arg el);
madm_list append_madm_list (madm_list l, madm el);
state_list append_state_list (state_list l, state el);
assoc_pair_list append_assoc_pair_list (assoc_pair_list l, assoc_pair el);
block_list append_block_list (block_list l, block el);
address_list append_address_list (address_list l, address el);
altnr_label_pair_list append_altnr_label_pair_list (altnr_label_pair_list l, altnr_label_pair el);
char_list append_char_list (char_list l, char el);

/* Introduce void shorthands for list append routines */
#define app_module_list(l,el) (void) append_module_list (l,el)
#define app_variable_list(l,el) (void) append_variable_list (l,el)
#define app_export_list(l,el) (void) append_export_list (l,el)
#define app_psig_list(l,el) (void) append_psig_list (l,el)
#define app_pdecl_list(l,el) (void) append_pdecl_list (l,el)
#define app_proc_list(l,el) (void) append_proc_list (l,el)
#define app_fpar_list(l,el) (void) append_fpar_list (l,el)
#define app_alternative_list(l,el) (void) append_alternative_list (l,el)
#define app_member_list(l,el) (void) append_member_list (l,el)
#define app_apar_list(l,el) (void) append_apar_list (l,el)
#define app_affix_term_list(l,el) (void) append_affix_term_list (l,el)
#define app_affix_rule_list(l,el) (void) append_affix_rule_list (l,el)
#define app_affix_alternative_list(l,el) (void) append_affix_alternative_list (l,el)
#define app_affix_element_list(l,el) (void) append_affix_element_list (l,el)
#define app_call_arg_list(l,el) (void) append_call_arg_list (l,el)
#define app_madm_list(l,el) (void) append_madm_list (l,el)
#define app_state_list(l,el) (void) append_state_list (l,el)
#define app_assoc_pair_list(l,el) (void) append_assoc_pair_list (l,el)
#define app_block_list(l,el) (void) append_block_list (l,el)
#define app_address_list(l,el) (void) append_address_list (l,el)
#define app_altnr_label_pair_list(l,el) (void) append_altnr_label_pair_list (l,el)
#define app_char_list(l,el) (void) append_char_list (l,el)

/* Introduce list concat routines */
module_list concat_module_list (module_list l1, module_list l2);
variable_list concat_variable_list (variable_list l1, variable_list l2);
export_list concat_export_list (export_list l1, export_list l2);
psig_list concat_psig_list (psig_list l1, psig_list l2);
pdecl_list concat_pdecl_list (pdecl_list l1, pdecl_list l2);
proc_list concat_proc_list (proc_list l1, proc_list l2);
fpar_list concat_fpar_list (fpar_list l1, fpar_list l2);
alternative_list concat_alternative_list (alternative_list l1, alternative_list l2);
member_list concat_member_list (member_list l1, member_list l2);
apar_list concat_apar_list (apar_list l1, apar_list l2);
affix_term_list concat_affix_term_list (affix_term_list l1, affix_term_list l2);
affix_rule_list concat_affix_rule_list (affix_rule_list l1, affix_rule_list l2);
affix_alternative_list concat_affix_alternative_list (affix_alternative_list l1, affix_alternative_list l2);
affix_element_list concat_affix_element_list (affix_element_list l1, affix_element_list l2);
call_arg_list concat_call_arg_list (call_arg_list l1, call_arg_list l2);
madm_list concat_madm_list (madm_list l1, madm_list l2);
state_list concat_state_list (state_list l1, state_list l2);
assoc_pair_list concat_assoc_pair_list (assoc_pair_list l1, assoc_pair_list l2);
block_list concat_block_list (block_list l1, block_list l2);
address_list concat_address_list (address_list l1, address_list l2);
altnr_label_pair_list concat_altnr_label_pair_list (altnr_label_pair_list l1, altnr_label_pair_list l2);
char_list concat_char_list (char_list l1, char_list l2);

/* Introduce void shorthands for list concat routines */
#define conc_module_list(l1,l2) (void) concat_module_list (l1,l2)
#define conc_variable_list(l1,l2) (void) concat_variable_list (l1,l2)
#define conc_export_list(l1,l2) (void) concat_export_list (l1,l2)
#define conc_psig_list(l1,l2) (void) concat_psig_list (l1,l2)
#define conc_pdecl_list(l1,l2) (void) concat_pdecl_list (l1,l2)
#define conc_proc_list(l1,l2) (void) concat_proc_list (l1,l2)
#define conc_fpar_list(l1,l2) (void) concat_fpar_list (l1,l2)
#define conc_alternative_list(l1,l2) (void) concat_alternative_list (l1,l2)
#define conc_member_list(l1,l2) (void) concat_member_list (l1,l2)
#define conc_apar_list(l1,l2) (void) concat_apar_list (l1,l2)
#define conc_affix_term_list(l1,l2) (void) concat_affix_term_list (l1,l2)
#define conc_affix_rule_list(l1,l2) (void) concat_affix_rule_list (l1,l2)
#define conc_affix_alternative_list(l1,l2) (void) concat_affix_alternative_list (l1,l2)
#define conc_affix_element_list(l1,l2) (void) concat_affix_element_list (l1,l2)
#define conc_call_arg_list(l1,l2) (void) concat_call_arg_list (l1,l2)
#define conc_madm_list(l1,l2) (void) concat_madm_list (l1,l2)
#define conc_state_list(l1,l2) (void) concat_state_list (l1,l2)
#define conc_assoc_pair_list(l1,l2) (void) concat_assoc_pair_list (l1,l2)
#define conc_block_list(l1,l2) (void) concat_block_list (l1,l2)
#define conc_address_list(l1,l2) (void) concat_address_list (l1,l2)
#define conc_altnr_label_pair_list(l1,l2) (void) concat_altnr_label_pair_list (l1,l2)
#define conc_char_list(l1,l2) (void) concat_char_list (l1,l2)

/* Introduce list insertion routines */
module_list insert_module_list (module_list l, int pos, module el);
variable_list insert_variable_list (variable_list l, int pos, variable el);
export_list insert_export_list (export_list l, int pos, export el);
psig_list insert_psig_list (psig_list l, int pos, psig el);
pdecl_list insert_pdecl_list (pdecl_list l, int pos, pdecl el);
proc_list insert_proc_list (proc_list l, int pos, proc el);
fpar_list insert_fpar_list (fpar_list l, int pos, fpar el);
alternative_list insert_alternative_list (alternative_list l, int pos, alternative el);
member_list insert_member_list (member_list l, int pos, member el);
apar_list insert_apar_list (apar_list l, int pos, apar el);
affix_term_list insert_affix_term_list (affix_term_list l, int pos, affix_term el);
affix_rule_list insert_affix_rule_list (affix_rule_list l, int pos, affix_rule el);
affix_alternative_list insert_affix_alternative_list (affix_alternative_list l, int pos, affix_alternative el);
affix_element_list insert_affix_element_list (affix_element_list l, int pos, affix_element el);
call_arg_list insert_call_arg_list (call_arg_list l, int pos, call_arg el);
madm_list insert_madm_list (madm_list l, int pos, madm el);
state_list insert_state_list (state_list l, int pos, state el);
assoc_pair_list insert_assoc_pair_list (assoc_pair_list l, int pos, assoc_pair el);
block_list insert_block_list (block_list l, int pos, block el);
address_list insert_address_list (address_list l, int pos, address el);
altnr_label_pair_list insert_altnr_label_pair_list (altnr_label_pair_list l, int pos, altnr_label_pair el);
char_list insert_char_list (char_list l, int pos, char el);

/* Introduce void shorthands for list insertion routines */
#define ins_module_list(l,pos,el) (void) insert_module_list (l,pos,el)
#define ins_variable_list(l,pos,el) (void) insert_variable_list (l,pos,el)
#define ins_export_list(l,pos,el) (void) insert_export_list (l,pos,el)
#define ins_psig_list(l,pos,el) (void) insert_psig_list (l,pos,el)
#define ins_pdecl_list(l,pos,el) (void) insert_pdecl_list (l,pos,el)
#define ins_proc_list(l,pos,el) (void) insert_proc_list (l,pos,el)
#define ins_fpar_list(l,pos,el) (void) insert_fpar_list (l,pos,el)
#define ins_alternative_list(l,pos,el) (void) insert_alternative_list (l,pos,el)
#define ins_member_list(l,pos,el) (void) insert_member_list (l,pos,el)
#define ins_apar_list(l,pos,el) (void) insert_apar_list (l,pos,el)
#define ins_affix_term_list(l,pos,el) (void) insert_affix_term_list (l,pos,el)
#define ins_affix_rule_list(l,pos,el) (void) insert_affix_rule_list (l,pos,el)
#define ins_affix_alternative_list(l,pos,el) (void) insert_affix_alternative_list (l,pos,el)
#define ins_affix_element_list(l,pos,el) (void) insert_affix_element_list (l,pos,el)
#define ins_call_arg_list(l,pos,el) (void) insert_call_arg_list (l,pos,el)
#define ins_madm_list(l,pos,el) (void) insert_madm_list (l,pos,el)
#define ins_state_list(l,pos,el) (void) insert_state_list (l,pos,el)
#define ins_assoc_pair_list(l,pos,el) (void) insert_assoc_pair_list (l,pos,el)
#define ins_block_list(l,pos,el) (void) insert_block_list (l,pos,el)
#define ins_address_list(l,pos,el) (void) insert_address_list (l,pos,el)
#define ins_altnr_label_pair_list(l,pos,el) (void) insert_altnr_label_pair_list (l,pos,el)
#define ins_char_list(l,pos,el) (void) insert_char_list (l,pos,el)

/* Introduce list deletion routines */
module_list delete_module_list (module_list l, int pos);
variable_list delete_variable_list (variable_list l, int pos);
export_list delete_export_list (export_list l, int pos);
psig_list delete_psig_list (psig_list l, int pos);
pdecl_list delete_pdecl_list (pdecl_list l, int pos);
proc_list delete_proc_list (proc_list l, int pos);
fpar_list delete_fpar_list (fpar_list l, int pos);
alternative_list delete_alternative_list (alternative_list l, int pos);
member_list delete_member_list (member_list l, int pos);
apar_list delete_apar_list (apar_list l, int pos);
affix_term_list delete_affix_term_list (affix_term_list l, int pos);
affix_rule_list delete_affix_rule_list (affix_rule_list l, int pos);
affix_alternative_list delete_affix_alternative_list (affix_alternative_list l, int pos);
affix_element_list delete_affix_element_list (affix_element_list l, int pos);
call_arg_list delete_call_arg_list (call_arg_list l, int pos);
madm_list delete_madm_list (madm_list l, int pos);
state_list delete_state_list (state_list l, int pos);
assoc_pair_list delete_assoc_pair_list (assoc_pair_list l, int pos);
block_list delete_block_list (block_list l, int pos);
address_list delete_address_list (address_list l, int pos);
altnr_label_pair_list delete_altnr_label_pair_list (altnr_label_pair_list l, int pos);
char_list delete_char_list (char_list l, int pos);

/* Introduce void shorthands for list deletion routines */
#define del_module_list(l,pos) (void) delete_module_list (l,pos)
#define del_variable_list(l,pos) (void) delete_variable_list (l,pos)
#define del_export_list(l,pos) (void) delete_export_list (l,pos)
#define del_psig_list(l,pos) (void) delete_psig_list (l,pos)
#define del_pdecl_list(l,pos) (void) delete_pdecl_list (l,pos)
#define del_proc_list(l,pos) (void) delete_proc_list (l,pos)
#define del_fpar_list(l,pos) (void) delete_fpar_list (l,pos)
#define del_alternative_list(l,pos) (void) delete_alternative_list (l,pos)
#define del_member_list(l,pos) (void) delete_member_list (l,pos)
#define del_apar_list(l,pos) (void) delete_apar_list (l,pos)
#define del_affix_term_list(l,pos) (void) delete_affix_term_list (l,pos)
#define del_affix_rule_list(l,pos) (void) delete_affix_rule_list (l,pos)
#define del_affix_alternative_list(l,pos) (void) delete_affix_alternative_list (l,pos)
#define del_affix_element_list(l,pos) (void) delete_affix_element_list (l,pos)
#define del_call_arg_list(l,pos) (void) delete_call_arg_list (l,pos)
#define del_madm_list(l,pos) (void) delete_madm_list (l,pos)
#define del_state_list(l,pos) (void) delete_state_list (l,pos)
#define del_assoc_pair_list(l,pos) (void) delete_assoc_pair_list (l,pos)
#define del_block_list(l,pos) (void) delete_block_list (l,pos)
#define del_address_list(l,pos) (void) delete_address_list (l,pos)
#define del_altnr_label_pair_list(l,pos) (void) delete_altnr_label_pair_list (l,pos)
#define del_char_list(l,pos) (void) delete_char_list (l,pos)

/* Equality test for types */
int cmp_module (module a, module b);
int cmp_variable (variable a, variable b);
int cmp_export (export a, export b);
int cmp_spec (spec a, spec b);
int cmp_psig (psig a, psig b);
int cmp_pdecl (pdecl a, pdecl b);
int cmp_proc (proc a, proc b);
#define cmp_proc_type(a,b) (cmp_int ((int)(a),(int)(b)))
int cmp_fpar (fpar a, fpar b);
#define cmp_dir(a,b) (cmp_int ((int)(a),(int)(b)))
int cmp_group (group a, group b);
int cmp_alternative (alternative a, alternative b);
int cmp_member (member a, member b);
int cmp_apar (apar a, apar b);
#define cmp_guard_type(a,b) (cmp_int ((int)(a),(int)(b)))
#define cmp_flow_op(a,b) (cmp_int ((int)(a),(int)(b)))
int cmp_affix_term (affix_term a, affix_term b);
int cmp_affix_rule (affix_rule a, affix_rule b);
int cmp_affix_alternative (affix_alternative a, affix_alternative b);
int cmp_affix_element (affix_element a, affix_element b);
int cmp_call_arg (call_arg a, call_arg b);
int cmp_madm (madm a, madm b);
#define cmp_state(a,b) (cmp_int ((int)(a),(int)(b)))
int cmp_assoc_pair (assoc_pair a, assoc_pair b);
int cmp_block (block a, block b);
int cmp_instr (instr a, instr b);
int cmp_address (address a, address b);
int cmp_altnr_label_pair (altnr_label_pair a, altnr_label_pair b);
int cmp_iexpr (iexpr a, iexpr b);
int cmp_rexpr (rexpr a, rexpr b);
#define cmp_operator(a,b) (cmp_int ((int)(a),(int)(b)))

/* Comparison tests for lists */
int cmp_module_list (module_list a, module_list b);
int cmp_variable_list (variable_list a, variable_list b);
int cmp_export_list (export_list a, export_list b);
int cmp_psig_list (psig_list a, psig_list b);
int cmp_pdecl_list (pdecl_list a, pdecl_list b);
int cmp_proc_list (proc_list a, proc_list b);
int cmp_fpar_list (fpar_list a, fpar_list b);
int cmp_alternative_list (alternative_list a, alternative_list b);
int cmp_member_list (member_list a, member_list b);
int cmp_apar_list (apar_list a, apar_list b);
int cmp_affix_term_list (affix_term_list a, affix_term_list b);
int cmp_affix_rule_list (affix_rule_list a, affix_rule_list b);
int cmp_affix_alternative_list (affix_alternative_list a, affix_alternative_list b);
int cmp_affix_element_list (affix_element_list a, affix_element_list b);
int cmp_call_arg_list (call_arg_list a, call_arg_list b);
int cmp_madm_list (madm_list a, madm_list b);
int cmp_state_list (state_list a, state_list b);
int cmp_assoc_pair_list (assoc_pair_list a, assoc_pair_list b);
int cmp_block_list (block_list a, block_list b);
int cmp_address_list (address_list a, address_list b);
int cmp_altnr_label_pair_list (altnr_label_pair_list a, altnr_label_pair_list b);
int cmp_char_list (char_list a, char_list b);

/* Equality shorthands for types */
#define equal_module(a,b) !cmp_module ((a),(b))
#define equal_variable(a,b) !cmp_variable ((a),(b))
#define equal_export(a,b) !cmp_export ((a),(b))
#define equal_spec(a,b) !cmp_spec ((a),(b))
#define equal_psig(a,b) !cmp_psig ((a),(b))
#define equal_pdecl(a,b) !cmp_pdecl ((a),(b))
#define equal_proc(a,b) !cmp_proc ((a),(b))
#define equal_proc_type(a,b) !cmp_proc_type ((a),(b))
#define equal_fpar(a,b) !cmp_fpar ((a),(b))
#define equal_dir(a,b) !cmp_dir ((a),(b))
#define equal_group(a,b) !cmp_group ((a),(b))
#define equal_alternative(a,b) !cmp_alternative ((a),(b))
#define equal_member(a,b) !cmp_member ((a),(b))
#define equal_apar(a,b) !cmp_apar ((a),(b))
#define equal_guard_type(a,b) !cmp_guard_type ((a),(b))
#define equal_flow_op(a,b) !cmp_flow_op ((a),(b))
#define equal_affix_term(a,b) !cmp_affix_term ((a),(b))
#define equal_affix_rule(a,b) !cmp_affix_rule ((a),(b))
#define equal_affix_alternative(a,b) !cmp_affix_alternative ((a),(b))
#define equal_affix_element(a,b) !cmp_affix_element ((a),(b))
#define equal_call_arg(a,b) !cmp_call_arg ((a),(b))
#define equal_madm(a,b) !cmp_madm ((a),(b))
#define equal_state(a,b) !cmp_state ((a),(b))
#define equal_assoc_pair(a,b) !cmp_assoc_pair ((a),(b))
#define equal_block(a,b) !cmp_block ((a),(b))
#define equal_instr(a,b) !cmp_instr ((a),(b))
#define equal_address(a,b) !cmp_address ((a),(b))
#define equal_altnr_label_pair(a,b) !cmp_altnr_label_pair ((a),(b))
#define equal_iexpr(a,b) !cmp_iexpr ((a),(b))
#define equal_rexpr(a,b) !cmp_rexpr ((a),(b))
#define equal_operator(a,b) !cmp_operator ((a),(b))

/* Equality shorthands for lists */
#define equal_module_list(a,b) !cmp_module_list((a),(b))
#define equal_variable_list(a,b) !cmp_variable_list((a),(b))
#define equal_export_list(a,b) !cmp_export_list((a),(b))
#define equal_psig_list(a,b) !cmp_psig_list((a),(b))
#define equal_pdecl_list(a,b) !cmp_pdecl_list((a),(b))
#define equal_proc_list(a,b) !cmp_proc_list((a),(b))
#define equal_fpar_list(a,b) !cmp_fpar_list((a),(b))
#define equal_alternative_list(a,b) !cmp_alternative_list((a),(b))
#define equal_member_list(a,b) !cmp_member_list((a),(b))
#define equal_apar_list(a,b) !cmp_apar_list((a),(b))
#define equal_affix_term_list(a,b) !cmp_affix_term_list((a),(b))
#define equal_affix_rule_list(a,b) !cmp_affix_rule_list((a),(b))
#define equal_affix_alternative_list(a,b) !cmp_affix_alternative_list((a),(b))
#define equal_affix_element_list(a,b) !cmp_affix_element_list((a),(b))
#define equal_call_arg_list(a,b) !cmp_call_arg_list((a),(b))
#define equal_madm_list(a,b) !cmp_madm_list((a),(b))
#define equal_state_list(a,b) !cmp_state_list((a),(b))
#define equal_assoc_pair_list(a,b) !cmp_assoc_pair_list((a),(b))
#define equal_block_list(a,b) !cmp_block_list((a),(b))
#define equal_address_list(a,b) !cmp_address_list((a),(b))
#define equal_altnr_label_pair_list(a,b) !cmp_altnr_label_pair_list((a),(b))
#define equal_char_list(a,b) !cmp_char_list((a),(b))

/* Estimating printing of types */
int est_module (module old);
int est_variable (variable old);
int est_export (export old);
int est_spec (spec old);
int est_psig (psig old);
int est_pdecl (pdecl old);
int est_proc (proc old);
int est_proc_type (proc_type old);
int est_fpar (fpar old);
int est_dir (dir old);
int est_group (group old);
int est_alternative (alternative old);
int est_member (member old);
int est_apar (apar old);
int est_guard_type (guard_type old);
int est_flow_op (flow_op old);
int est_affix_term (affix_term old);
int est_affix_rule (affix_rule old);
int est_affix_alternative (affix_alternative old);
int est_affix_element (affix_element old);
int est_call_arg (call_arg old);
int est_madm (madm old);
int est_state (state old);
int est_assoc_pair (assoc_pair old);
int est_block (block old);
int est_instr (instr old);
int est_address (address old);
int est_altnr_label_pair (altnr_label_pair old);
int est_iexpr (iexpr old);
int est_rexpr (rexpr old);
int est_operator (operator old);

/* Estimate printing of lists */
int est_module_list (module_list old);
int est_variable_list (variable_list old);
int est_export_list (export_list old);
int est_psig_list (psig_list old);
int est_pdecl_list (pdecl_list old);
int est_proc_list (proc_list old);
int est_fpar_list (fpar_list old);
int est_alternative_list (alternative_list old);
int est_member_list (member_list old);
int est_apar_list (apar_list old);
int est_affix_term_list (affix_term_list old);
int est_affix_rule_list (affix_rule_list old);
int est_affix_alternative_list (affix_alternative_list old);
int est_affix_element_list (affix_element_list old);
int est_call_arg_list (call_arg_list old);
int est_madm_list (madm_list old);
int est_state_list (state_list old);
int est_assoc_pair_list (assoc_pair_list old);
int est_block_list (block_list old);
int est_address_list (address_list old);
int est_altnr_label_pair_list (altnr_label_pair_list old);
int est_char_list (char_list old);

void ppp_module (FILE *f, int horiz, int ind, module old);
void ppp_variable (FILE *f, int horiz, int ind, variable old);
void ppp_export (FILE *f, int horiz, int ind, export old);
void ppp_spec (FILE *f, int horiz, int ind, spec old);
void ppp_psig (FILE *f, int horiz, int ind, psig old);
void ppp_pdecl (FILE *f, int horiz, int ind, pdecl old);
void ppp_proc (FILE *f, int horiz, int ind, proc old);
void ppp_proc_type (FILE *f, int horiz, int ind, proc_type old);
void ppp_fpar (FILE *f, int horiz, int ind, fpar old);
void ppp_dir (FILE *f, int horiz, int ind, dir old);
void ppp_group (FILE *f, int horiz, int ind, group old);
void ppp_alternative (FILE *f, int horiz, int ind, alternative old);
void ppp_member (FILE *f, int horiz, int ind, member old);
void ppp_apar (FILE *f, int horiz, int ind, apar old);
void ppp_guard_type (FILE *f, int horiz, int ind, guard_type old);
void ppp_flow_op (FILE *f, int horiz, int ind, flow_op old);
void ppp_affix_term (FILE *f, int horiz, int ind, affix_term old);
void ppp_affix_rule (FILE *f, int horiz, int ind, affix_rule old);
void ppp_affix_alternative (FILE *f, int horiz, int ind, affix_alternative old);
void ppp_affix_element (FILE *f, int horiz, int ind, affix_element old);
void ppp_call_arg (FILE *f, int horiz, int ind, call_arg old);
void ppp_madm (FILE *f, int horiz, int ind, madm old);
void ppp_state (FILE *f, int horiz, int ind, state old);
void ppp_assoc_pair (FILE *f, int horiz, int ind, assoc_pair old);
void ppp_block (FILE *f, int horiz, int ind, block old);
void ppp_instr (FILE *f, int horiz, int ind, instr old);
void ppp_address (FILE *f, int horiz, int ind, address old);
void ppp_altnr_label_pair (FILE *f, int horiz, int ind, altnr_label_pair old);
void ppp_iexpr (FILE *f, int horiz, int ind, iexpr old);
void ppp_rexpr (FILE *f, int horiz, int ind, rexpr old);
void ppp_operator (FILE *f, int horiz, int ind, operator old);

/* Introduce pretty printing of lists */
void ppp_module_list (FILE *f, int horiz, int ind, module_list old);
void ppp_variable_list (FILE *f, int horiz, int ind, variable_list old);
void ppp_export_list (FILE *f, int horiz, int ind, export_list old);
void ppp_psig_list (FILE *f, int horiz, int ind, psig_list old);
void ppp_pdecl_list (FILE *f, int horiz, int ind, pdecl_list old);
void ppp_proc_list (FILE *f, int horiz, int ind, proc_list old);
void ppp_fpar_list (FILE *f, int horiz, int ind, fpar_list old);
void ppp_alternative_list (FILE *f, int horiz, int ind, alternative_list old);
void ppp_member_list (FILE *f, int horiz, int ind, member_list old);
void ppp_apar_list (FILE *f, int horiz, int ind, apar_list old);
void ppp_affix_term_list (FILE *f, int horiz, int ind, affix_term_list old);
void ppp_affix_rule_list (FILE *f, int horiz, int ind, affix_rule_list old);
void ppp_affix_alternative_list (FILE *f, int horiz, int ind, affix_alternative_list old);
void ppp_affix_element_list (FILE *f, int horiz, int ind, affix_element_list old);
void ppp_call_arg_list (FILE *f, int horiz, int ind, call_arg_list old);
void ppp_madm_list (FILE *f, int horiz, int ind, madm_list old);
void ppp_state_list (FILE *f, int horiz, int ind, state_list old);
void ppp_assoc_pair_list (FILE *f, int horiz, int ind, assoc_pair_list old);
void ppp_block_list (FILE *f, int horiz, int ind, block_list old);
void ppp_address_list (FILE *f, int horiz, int ind, address_list old);
void ppp_altnr_label_pair_list (FILE *f, int horiz, int ind, altnr_label_pair_list old);
void ppp_char_list (FILE *f, int horiz, int ind, char_list old);

/* Introduce pretty printing shorthands */
#define pp_module(f,x) ppp_module (f,0,0,x)
#define pp_variable(f,x) ppp_variable (f,0,0,x)
#define pp_export(f,x) ppp_export (f,0,0,x)
#define pp_spec(f,x) ppp_spec (f,0,0,x)
#define pp_psig(f,x) ppp_psig (f,0,0,x)
#define pp_pdecl(f,x) ppp_pdecl (f,0,0,x)
#define pp_proc(f,x) ppp_proc (f,0,0,x)
#define pp_proc_type(f,x) ppp_proc_type (f,0,0,x)
#define pp_fpar(f,x) ppp_fpar (f,0,0,x)
#define pp_dir(f,x) ppp_dir (f,0,0,x)
#define pp_group(f,x) ppp_group (f,0,0,x)
#define pp_alternative(f,x) ppp_alternative (f,0,0,x)
#define pp_member(f,x) ppp_member (f,0,0,x)
#define pp_apar(f,x) ppp_apar (f,0,0,x)
#define pp_guard_type(f,x) ppp_guard_type (f,0,0,x)
#define pp_flow_op(f,x) ppp_flow_op (f,0,0,x)
#define pp_affix_term(f,x) ppp_affix_term (f,0,0,x)
#define pp_affix_rule(f,x) ppp_affix_rule (f,0,0,x)
#define pp_affix_alternative(f,x) ppp_affix_alternative (f,0,0,x)
#define pp_affix_element(f,x) ppp_affix_element (f,0,0,x)
#define pp_call_arg(f,x) ppp_call_arg (f,0,0,x)
#define pp_madm(f,x) ppp_madm (f,0,0,x)
#define pp_state(f,x) ppp_state (f,0,0,x)
#define pp_assoc_pair(f,x) ppp_assoc_pair (f,0,0,x)
#define pp_block(f,x) ppp_block (f,0,0,x)
#define pp_instr(f,x) ppp_instr (f,0,0,x)
#define pp_address(f,x) ppp_address (f,0,0,x)
#define pp_altnr_label_pair(f,x) ppp_altnr_label_pair (f,0,0,x)
#define pp_iexpr(f,x) ppp_iexpr (f,0,0,x)
#define pp_rexpr(f,x) ppp_rexpr (f,0,0,x)
#define pp_operator(f,x) ppp_operator (f,0,0,x)

/* Introduce pretty printing shorthands for lists */
#define pp_module_list(f,x) ppp_module_list (f,0,0,x)
#define pp_variable_list(f,x) ppp_variable_list (f,0,0,x)
#define pp_export_list(f,x) ppp_export_list (f,0,0,x)
#define pp_psig_list(f,x) ppp_psig_list (f,0,0,x)
#define pp_pdecl_list(f,x) ppp_pdecl_list (f,0,0,x)
#define pp_proc_list(f,x) ppp_proc_list (f,0,0,x)
#define pp_fpar_list(f,x) ppp_fpar_list (f,0,0,x)
#define pp_alternative_list(f,x) ppp_alternative_list (f,0,0,x)
#define pp_member_list(f,x) ppp_member_list (f,0,0,x)
#define pp_apar_list(f,x) ppp_apar_list (f,0,0,x)
#define pp_affix_term_list(f,x) ppp_affix_term_list (f,0,0,x)
#define pp_affix_rule_list(f,x) ppp_affix_rule_list (f,0,0,x)
#define pp_affix_alternative_list(f,x) ppp_affix_alternative_list (f,0,0,x)
#define pp_affix_element_list(f,x) ppp_affix_element_list (f,0,0,x)
#define pp_call_arg_list(f,x) ppp_call_arg_list (f,0,0,x)
#define pp_madm_list(f,x) ppp_madm_list (f,0,0,x)
#define pp_state_list(f,x) ppp_state_list (f,0,0,x)
#define pp_assoc_pair_list(f,x) ppp_assoc_pair_list (f,0,0,x)
#define pp_block_list(f,x) ppp_block_list (f,0,0,x)
#define pp_address_list(f,x) ppp_address_list (f,0,0,x)
#define pp_altnr_label_pair_list(f,x) ppp_altnr_label_pair_list (f,0,0,x)
#define pp_char_list(f,x) ppp_char_list (f,0,0,x)

/* Introduce saving of types */
#define save_proc_type(bf,x) save_char(bf, (char) x)
#define save_dir(bf,x) save_char(bf, (char) x)
#define save_guard_type(bf,x) save_char(bf, (char) x)
#define save_flow_op(bf,x) save_char(bf, (char) x)
#define save_state(bf,x) save_char(bf, (char) x)
#define save_operator(bf,x) save_char(bf, (char) x)
void save_module (BinFile bf, module old);
void save_variable (BinFile bf, variable old);
void save_export (BinFile bf, export old);
void save_spec (BinFile bf, spec old);
void save_psig (BinFile bf, psig old);
void save_pdecl (BinFile bf, pdecl old);
void save_proc (BinFile bf, proc old);
void save_fpar (BinFile bf, fpar old);
void save_group (BinFile bf, group old);
void save_alternative (BinFile bf, alternative old);
void save_member (BinFile bf, member old);
void save_apar (BinFile bf, apar old);
void save_affix_term (BinFile bf, affix_term old);
void save_affix_rule (BinFile bf, affix_rule old);
void save_affix_alternative (BinFile bf, affix_alternative old);
void save_affix_element (BinFile bf, affix_element old);
void save_call_arg (BinFile bf, call_arg old);
void save_madm (BinFile bf, madm old);
void save_assoc_pair (BinFile bf, assoc_pair old);
void save_block (BinFile bf, block old);
void save_instr (BinFile bf, instr old);
void save_address (BinFile bf, address old);
void save_altnr_label_pair (BinFile bf, altnr_label_pair old);
void save_iexpr (BinFile bf, iexpr old);
void save_rexpr (BinFile bf, rexpr old);

/* Introduce saving of lists */
void save_module_list (BinFile bf, module_list l);
void save_variable_list (BinFile bf, variable_list l);
void save_export_list (BinFile bf, export_list l);
void save_psig_list (BinFile bf, psig_list l);
void save_pdecl_list (BinFile bf, pdecl_list l);
void save_proc_list (BinFile bf, proc_list l);
void save_fpar_list (BinFile bf, fpar_list l);
void save_alternative_list (BinFile bf, alternative_list l);
void save_member_list (BinFile bf, member_list l);
void save_apar_list (BinFile bf, apar_list l);
void save_affix_term_list (BinFile bf, affix_term_list l);
void save_affix_rule_list (BinFile bf, affix_rule_list l);
void save_affix_alternative_list (BinFile bf, affix_alternative_list l);
void save_affix_element_list (BinFile bf, affix_element_list l);
void save_call_arg_list (BinFile bf, call_arg_list l);
void save_madm_list (BinFile bf, madm_list l);
void save_state_list (BinFile bf, state_list l);
void save_assoc_pair_list (BinFile bf, assoc_pair_list l);
void save_block_list (BinFile bf, block_list l);
void save_address_list (BinFile bf, address_list l);
void save_altnr_label_pair_list (BinFile bf, altnr_label_pair_list l);
void save_char_list (BinFile bf, char_list l);

/* Introduce loading of types */
void load_module (BinFile bf, module *x);
void load_variable (BinFile bf, variable *x);
void load_export (BinFile bf, export *x);
void load_spec (BinFile bf, spec *x);
void load_psig (BinFile bf, psig *x);
void load_pdecl (BinFile bf, pdecl *x);
void load_proc (BinFile bf, proc *x);
void load_proc_type (BinFile bf, proc_type *x);
void load_fpar (BinFile bf, fpar *x);
void load_dir (BinFile bf, dir *x);
void load_group (BinFile bf, group *x);
void load_alternative (BinFile bf, alternative *x);
void load_member (BinFile bf, member *x);
void load_apar (BinFile bf, apar *x);
void load_guard_type (BinFile bf, guard_type *x);
void load_flow_op (BinFile bf, flow_op *x);
void load_affix_term (BinFile bf, affix_term *x);
void load_affix_rule (BinFile bf, affix_rule *x);
void load_affix_alternative (BinFile bf, affix_alternative *x);
void load_affix_element (BinFile bf, affix_element *x);
void load_call_arg (BinFile bf, call_arg *x);
void load_madm (BinFile bf, madm *x);
void load_state (BinFile bf, state *x);
void load_assoc_pair (BinFile bf, assoc_pair *x);
void load_block (BinFile bf, block *x);
void load_instr (BinFile bf, instr *x);
void load_address (BinFile bf, address *x);
void load_altnr_label_pair (BinFile bf, altnr_label_pair *x);
void load_iexpr (BinFile bf, iexpr *x);
void load_rexpr (BinFile bf, rexpr *x);
void load_operator (BinFile bf, operator *x);

/* Introduce loading of lists */
void load_module_list (BinFile bf, module_list *l);
void load_variable_list (BinFile bf, variable_list *l);
void load_export_list (BinFile bf, export_list *l);
void load_psig_list (BinFile bf, psig_list *l);
void load_pdecl_list (BinFile bf, pdecl_list *l);
void load_proc_list (BinFile bf, proc_list *l);
void load_fpar_list (BinFile bf, fpar_list *l);
void load_alternative_list (BinFile bf, alternative_list *l);
void load_member_list (BinFile bf, member_list *l);
void load_apar_list (BinFile bf, apar_list *l);
void load_affix_term_list (BinFile bf, affix_term_list *l);
void load_affix_rule_list (BinFile bf, affix_rule_list *l);
void load_affix_alternative_list (BinFile bf, affix_alternative_list *l);
void load_affix_element_list (BinFile bf, affix_element_list *l);
void load_call_arg_list (BinFile bf, call_arg_list *l);
void load_madm_list (BinFile bf, madm_list *l);
void load_state_list (BinFile bf, state_list *l);
void load_assoc_pair_list (BinFile bf, assoc_pair_list *l);
void load_block_list (BinFile bf, block_list *l);
void load_address_list (BinFile bf, address_list *l);
void load_altnr_label_pair_list (BinFile bf, altnr_label_pair_list *l);
void load_char_list (BinFile bf, char_list *l);

/* Introduce recursive duplication of types */
module rdup_module (module old);
variable rdup_variable (variable old);
export rdup_export (export old);
spec rdup_spec (spec old);
psig rdup_psig (psig old);
pdecl rdup_pdecl (pdecl old);
proc rdup_proc (proc old);
#define rdup_proc_type(orig) (orig)
fpar rdup_fpar (fpar old);
#define rdup_dir(orig) (orig)
group rdup_group (group old);
alternative rdup_alternative (alternative old);
member rdup_member (member old);
apar rdup_apar (apar old);
#define rdup_guard_type(orig) (orig)
#define rdup_flow_op(orig) (orig)
affix_term rdup_affix_term (affix_term old);
affix_rule rdup_affix_rule (affix_rule old);
affix_alternative rdup_affix_alternative (affix_alternative old);
affix_element rdup_affix_element (affix_element old);
call_arg rdup_call_arg (call_arg old);
madm rdup_madm (madm old);
#define rdup_state(orig) (orig)
assoc_pair rdup_assoc_pair (assoc_pair old);
block rdup_block (block old);
instr rdup_instr (instr old);
address rdup_address (address old);
altnr_label_pair rdup_altnr_label_pair (altnr_label_pair old);
iexpr rdup_iexpr (iexpr old);
rexpr rdup_rexpr (rexpr old);
#define rdup_operator(orig) (orig)

/* Introduce recursive copying of lists */
module_list rdup_module_list (module_list old);
variable_list rdup_variable_list (variable_list old);
export_list rdup_export_list (export_list old);
psig_list rdup_psig_list (psig_list old);
pdecl_list rdup_pdecl_list (pdecl_list old);
proc_list rdup_proc_list (proc_list old);
fpar_list rdup_fpar_list (fpar_list old);
alternative_list rdup_alternative_list (alternative_list old);
member_list rdup_member_list (member_list old);
apar_list rdup_apar_list (apar_list old);
affix_term_list rdup_affix_term_list (affix_term_list old);
affix_rule_list rdup_affix_rule_list (affix_rule_list old);
affix_alternative_list rdup_affix_alternative_list (affix_alternative_list old);
affix_element_list rdup_affix_element_list (affix_element_list old);
call_arg_list rdup_call_arg_list (call_arg_list old);
madm_list rdup_madm_list (madm_list old);
state_list rdup_state_list (state_list old);
assoc_pair_list rdup_assoc_pair_list (assoc_pair_list old);
block_list rdup_block_list (block_list old);
address_list rdup_address_list (address_list old);
altnr_label_pair_list rdup_altnr_label_pair_list (altnr_label_pair_list old);
char_list rdup_char_list (char_list old);

/* Introduce recursive refcount checking of types */
void check_not_freed_module (module curr);
void check_not_freed_variable (variable curr);
void check_not_freed_export (export curr);
void check_not_freed_spec (spec curr);
void check_not_freed_psig (psig curr);
void check_not_freed_pdecl (pdecl curr);
void check_not_freed_proc (proc curr);
#define check_not_freed_proc_type(curr)
void check_not_freed_fpar (fpar curr);
#define check_not_freed_dir(curr)
void check_not_freed_group (group curr);
void check_not_freed_alternative (alternative curr);
void check_not_freed_member (member curr);
void check_not_freed_apar (apar curr);
#define check_not_freed_guard_type(curr)
#define check_not_freed_flow_op(curr)
void check_not_freed_affix_term (affix_term curr);
void check_not_freed_affix_rule (affix_rule curr);
void check_not_freed_affix_alternative (affix_alternative curr);
void check_not_freed_affix_element (affix_element curr);
void check_not_freed_call_arg (call_arg curr);
void check_not_freed_madm (madm curr);
#define check_not_freed_state(curr)
void check_not_freed_assoc_pair (assoc_pair curr);
void check_not_freed_block (block curr);
void check_not_freed_instr (instr curr);
void check_not_freed_address (address curr);
void check_not_freed_altnr_label_pair (altnr_label_pair curr);
void check_not_freed_iexpr (iexpr curr);
void check_not_freed_rexpr (rexpr curr);
#define check_not_freed_operator(curr)

/* Introduce recursive refcount checking of lists */
void check_not_freed_module_list (module_list curr);
void check_not_freed_variable_list (variable_list curr);
void check_not_freed_export_list (export_list curr);
void check_not_freed_psig_list (psig_list curr);
void check_not_freed_pdecl_list (pdecl_list curr);
void check_not_freed_proc_list (proc_list curr);
void check_not_freed_fpar_list (fpar_list curr);
void check_not_freed_alternative_list (alternative_list curr);
void check_not_freed_member_list (member_list curr);
void check_not_freed_apar_list (apar_list curr);
void check_not_freed_affix_term_list (affix_term_list curr);
void check_not_freed_affix_rule_list (affix_rule_list curr);
void check_not_freed_affix_alternative_list (affix_alternative_list curr);
void check_not_freed_affix_element_list (affix_element_list curr);
void check_not_freed_call_arg_list (call_arg_list curr);
void check_not_freed_madm_list (madm_list curr);
void check_not_freed_state_list (state_list curr);
void check_not_freed_assoc_pair_list (assoc_pair_list curr);
void check_not_freed_block_list (block_list curr);
void check_not_freed_address_list (address_list curr);
void check_not_freed_altnr_label_pair_list (altnr_label_pair_list curr);
void check_not_freed_char_list (char_list curr);

#endif /* IncCdl_ds */
