/*
   File: globals.c
   Copyright (C) 2010 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: globals.c,v 1.1 2010/06/12 12:54:24 marcs Exp $"
*/

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"
#include "globals.h"

/* Exported list of all modules and pointer to the root */
module_list all_modules;
module root_module;

/* Exported list of all affix rule definitions, but not imports */
affix_rule_list all_affix_rules;

/* List of all global variables */
variable_list all_global_variables;

/* Exported list of all procedures */
proc_list all_procedures;

#define INIT_NR_OF_AFFIX_RULES 256
#define INIT_NR_OF_GLOBAL_VARS 256
#define INIT_NR_OF_PROCEDURES 1024
void init_globals ()
{ all_affix_rules = init_affix_rule_list (INIT_NR_OF_AFFIX_RULES);
  all_global_variables = init_variable_list (INIT_NR_OF_GLOBAL_VARS);
  all_procedures = init_proc_list (INIT_NR_OF_PROCEDURES);
  all_modules = new_module_list ();
  root_module = module_nil;
}
