/*
   File: members.h
   Checks and resolves guards and calls, simplifies affix expressions 
   and infers implicit equals due to consistent substitution

   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: members.h,v 1.8 2008/06/28 13:38:29 marcs Exp $"
*/
#ifndef IncMembers
#define IncMembers

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"

/* Exported functions */
void check_members (member_list mems, variable_list pvars, module mod);
void check_members2 (member_list mems, proc p);
void check_members3 (member_list mems, proc p);

#endif /* IncMembers */
