/*
   File: options.h
   Defines flags and parameters of the mcdl compiler
   It also specifies some compiler defaults

   Copyright (C) 2008-2010 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: options.h,v 1.14 2010/09/29 11:41:03 marcs Exp $"
*/
#ifndef IncOptions
#define IncOptions

/* libdcg and local includes */
#include <dcg.h>
#include <dcg_string.h>
#include "cdl_ds.h"

/* Exported flags and pragmats */
extern int interactive_compilation;
extern int partial_compilation;
extern int cdlc_compatible;
extern int strict_export;
extern int parse_only;
extern int no_code;

/* Exported code generation flags */
extern int generate_c_code;
extern int generate_object;
extern int optimize_code;
extern int no_code;

/* exported debug flags */
extern int debug;
extern int dump_parser;
extern int dump_checker;
extern int dump_intermed;
extern int dump_optimizer;
extern int dump_flow;
extern int dump_affix_rules;

/* exported search path */
extern string_list module_search_path;

/* Source file names */
extern string dir_name;
extern string base_mname;
extern string source_name;

/* Output file names */
extern string output_fname;
extern string object_fname;
extern string c_code_fname;
extern string header_fname;

/* exported link configuration */
extern string_list library_search_path;
extern string_list link_library_names;

/* exported routines */
void init_options ();
void parse_command_line (int argc, char **argv);

#endif /* IncOptions */
