/*
   File: procedures.h
   Checks the procedures

   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: procedures.h,v 1.14 2010/06/12 12:54:24 marcs Exp $"
*/
#ifndef IncProcedures
#define IncProcedures

/* standard includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>
#include <dcg_string.h>

/* local includes */
#include "cdl_ds.h"

/* Introduce signatures */
typedef psig_list signature;

/* Exported functions */
pdecl_list pre_identify_procedure (string_list pname_parts, int p1nr, int p2nr, module mod);
void check_group (group grp, variable_list pvars, module mod);
void check_group2 (group grp, proc p);
void check_group3 (group grp, proc p);
void check_procedures ();

#endif /* IncProcedures */
