/*
   File: warshall.c
   Implements Warshalls algorithm
  
   Copyright (C) 2008 Marc Seutter

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   CVS ID: "$Id: warshall.c,v 1.2 2008/06/28 13:38:29 marcs Exp $"
*/

/* general includes */
#include <stdio.h>

/* libdcg includes */
#include <dcg.h>
#include <dcg_alloc.h>

/* local includes */
#include "warshall.h"

char *warshall (int n, char *rel)
{ /* Allocate array for result relation */
  char *result = (char *) dcg_calloc (n*n, sizeof (char));
  int i,j,k;

  /* Copy the original relation into the result */
  for (i=0; i<n; i++)
    for (j=0; j<n; j++) result[i * n + j] = rel[i * n + j];

  /* Take closure */
  for (k=0; k<n; k++)
    for (i=0; i<n; i++)
      for (j=0; j<n; j++)
	result[i * n + j] = result[i * n + j] || (result[i * n + k] && result [k * n + j]);

  return (result);
};
